//+------------------------------------------------------------------+
//|                                                       VQbars.mq5 |
//|                                       Copyright  2011, raff1410 | 
//|                                                   raff1410@o2.pl | 
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, raff1410"
#property link "raff1410@o2.pl"
#property description "VQbars"
//----   
#property version   "1.00"
//----     
#property indicator_chart_window 
//----        
#property indicator_buffers 2
//----     
#property indicator_plots   1
//+----------------------------------------------+
//|                  |
//+----------------------------------------------+
//----     
#property indicator_type1   DRAW_COLOR_ARROW
//----     
#property indicator_color1  Gray,Magenta,Blue
//----     4
#property indicator_width1  4
//----   
#property indicator_label1  "VQbars Flat,VQbars Sell,VQbars Buy"
//+-----------------------------------+
//|                 |
//+-----------------------------------+
#define RESET  0    //        
//+-----------------------------------+
//|          |
//+-----------------------------------+
#include <SmoothAlgorithms.mqh> 
//+-----------------------------------+
//----    CXMA  CMomentum   SmoothAlgorithms.mqh
CXMA XMAO,XMAL,XMAH,XMAC;
CMomentum MOM;
//+-----------------------------------+
//|             |
//+-----------------------------------+
enum Applied_price_      //  
  {
   PRICE_CLOSE_ = 1,     // Close
   PRICE_OPEN_,          // Open
   PRICE_HIGH_,          // High
   PRICE_LOW_,           // Low
   PRICE_MEDIAN_,        // Median Price (HL/2)
   PRICE_TYPICAL_,       // Typical Price (HLC/3)
   PRICE_WEIGHTED_,      // Weighted Close (HLCC/4)
   PRICE_SIMPLE,         // Simple Price (OC/2)
   PRICE_QUARTER_,       // Quarted Price (HLOC/4) 
   PRICE_TRENDFOLLOW0_,  // TrendFollow_1 Price 
   PRICE_TRENDFOLLOW1_   // TrendFollow_2 Price 
  };
/*enum Smooth_Method -     SmoothAlgorithms.mqh
  {
   MODE_SMA_,  // SMA
   MODE_EMA_,  // EMA
   MODE_SMMA_, // SMMA
   MODE_LWMA_, // LWMA
   MODE_JJMA,  // JJMA
   MODE_JurX,  // JurX
   MODE_ParMA, // ParMA
   MODE_T3,    // T3
   MODE_VIDYA, // VIDYA
   MODE_AMA,   // AMA
  }; */
//+-----------------------------------+
//|         |
//+-----------------------------------+
input Smooth_Method VQMA_Method=MODE_SMA; //  
input int VQLength=12;                    //                      
input int VQPhase=15;                     //  
input Applied_price_ IPC=PRICE_CLOSE;     //  
input int VQMomentum=1;                   // 
input uint Filter=5;                      //  
input int Shift=0;                        //      
//+----------------------------------------------+
//----   ,   
//----      
double IndBuffer[];
double ColorIndBuffer[];
//----      
int min_rates_total,xmin_rates_total,min_rates_total_;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void OnInit()
  {
//----     
   xmin_rates_total=XMAO.GetStartBars(VQMA_Method,VQLength,VQPhase);
   min_rates_total=xmin_rates_total+VQMomentum+1;
   min_rates_total_=min_rates_total-1;
//----       
   XMAO.XMALengthCheck("VQLength", VQLength);
   XMAO.XMAPhaseCheck("VQPhase", VQPhase, VQMA_Method);

//----    IndBuffer[]   
   SetIndexBuffer(0,IndBuffer,INDICATOR_DATA);
//----       1
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//----   
   PlotIndexSetInteger(0,PLOT_ARROW,108);
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0);
//----    1  
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);

//----    ColorIndBuffer[]       
   SetIndexBuffer(1,ColorIndBuffer,INDICATOR_COLOR_INDEX);
//----      
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,min_rates_total);

//----     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//----         
   string short_name="VQbars";
   IndicatorSetString(INDICATOR_SHORTNAME,short_name);
//----   
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//----       
   if(rates_total<min_rates_total) return(RESET);

//----    
   int first,bar,trend0,bar0;
   double MH,ML,MO,MC,MC1,VQ=0.0,SumVQ0,SumVQ1;
   static double SumVQ1_;
   static int trend1;

//----    first    
   if(prev_calculated>rates_total || prev_calculated<=0) //      
     {
      first=0;                   //      
      SumVQ1_=close[min_rates_total_];
     }
   else first=prev_calculated-1; //      

   bar0=rates_total-1;

//----   
   SumVQ1=SumVQ1_;

//----    
   for(bar=first; bar<rates_total && !IsStopped(); bar++)
     {
      //----        
      if(rates_total!=prev_calculated && bar==bar0) SumVQ1_=SumVQ1;

      //---- 4   XMASeries
      MO = XMAO.XMASeries(0, prev_calculated, rates_total, VQMA_Method, VQPhase, VQLength, open [bar], bar, false);
      MC = XMAC.XMASeries(0, prev_calculated, rates_total, VQMA_Method, VQPhase, VQLength, close[bar], bar, false);
      MH = XMAH.XMASeries(0, prev_calculated, rates_total, VQMA_Method, VQPhase, VQLength, high [bar], bar, false);
      ML = XMAL.XMASeries(0, prev_calculated, rates_total, VQMA_Method, VQPhase, VQLength, low  [bar], bar, false);
      MC1= MC-MOM.MomentumSeries(xmin_rates_total,prev_calculated,rates_total,VQMomentum,MC,bar,false);
      if(bar<min_rates_total) continue;

      if(MH-ML>0) VQ=MathAbs(((MC-MC1)/MathMax(MH-ML,MathMax(MH-MC1,MC1-ML))+(MC-MO)/(MH-ML))*0.5)*((MC-MC1+(MC-MO))*0.5);
      SumVQ0=SumVQ1+VQ;

      if(bar<=min_rates_total)
        {
         SumVQ1=SumVQ0;
         continue;
        }

      if(Filter && MathAbs(SumVQ0-SumVQ1)<Filter*_Point) SumVQ0=SumVQ1;

      trend0=trend1;
      if(SumVQ0 > SumVQ1) trend0=+1;
      if(SumVQ0 < SumVQ1) trend0=-1;

      IndBuffer[bar]=MC;
      ColorIndBuffer[bar]=0;

      if(trend0>0) ColorIndBuffer[bar]=2;
      else if(trend0<0) ColorIndBuffer[bar]=1;

      if(bar!=bar0) trend1=trend0;
      SumVQ1=SumVQ0;
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
